<script>
  // Import
  import { scaleLog, scaleLinear, scaleOrdinal } from 'd3-scale';
  import { schemeDark2 } from 'd3-scale-chromatic';
  import { extent } from 'd3-array';
  import { select } from 'd3-selection';
  import { axisLeft, axisBottom } from 'd3-axis';

  // Export
  export let data = null;

  // Dimensions
  const [height, width] = [400, 600];
  const margin = { top: 50, right: 5, bottom: 55, left: 50 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales
  const scaleX = scaleLog().domain([200,100000]).range([0, innerWidth]);
  const scaleY = scaleLinear().domain([90, 0]).range([0, innerHeight]);
  const scaleRadius = scaleLinear().domain(extent(data.map(item => item.population))).range([3, 13]);
  const colorCategory = scaleOrdinal(schemeDark2).domain(extent(data.map(item => item.continent)));

  // Axis
  const axisX = axisBottom(scaleX).tickValues([400, 4000, 40000]).tickFormat(tick => `$${tick}`);;
  const axisY = axisLeft(scaleY);

  function aX(x) {
    axisX(select(x));
  }

  function aY(y) {
    axisY(select(y));
  }

</script>

<svg viewBox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform="translate({margin.left}, {margin.top})">
    <!--  -->
    {#each data as item}
      <circle cx={scaleX(+item.income)} cy={scaleY(+item.life_exp)} r={scaleRadius(+item.population)} fill={colorCategory(item.continent)}/>
    {/each}
    <!-- X and Y axis -->
    <text x=40% y={innerHeight + margin.bottom/2} font-size='small'> GDP per Capita </text>
    <text x={-4*margin.left} y={-margin.left/2} transform="rotate(270)" font-size='small'> Life Expectancy </text>
    <!-- Title -->
    <text x=25% y= 0% font-size='x-large'> Gapminder Scatterplot </text>
    <!-- Year -->
    <text x=85% y=70% font-size='large' fill='grey'>1800</text>
  </g>
  <g transform="translate({margin.left}, {innerHeight + margin.top})" use:aX></g>
  <g transform="translate({margin.left}, {margin.top})" use:aY></g>
</svg>